// compile:   g++ -Wall VirtualFunctions-CPP.cpp -o VirtualFunctions-CPP
// hierarchy: g++ -Wall VirtualFunctions-CPP.cpp -o VirtualFunctions-CPP -fdump-class-hierarchy

// Questions
//  -Is there any runtime cost associated with this example?
//  -How can non-virtual destructors lead to memory leaks, etc.?

#include <iostream>

struct Base {
  float x;

  Base(const float x) { this->x = x; }
  virtual ~Base()             { }

  virtual void print() const { std::cout << x << std::endl; }
};

struct Derived : Base {
  float y;

  Derived(const float x,const float y) : Base(x) { this->y = y; }
  ~Derived()                                     { }

  virtual void print() const { Base::print(); std::cout << y << std::endl; }
};


int main() {
  Derived x(1.0,2.0);
  Base &y = x;

  std::cout << "Printing x:" << std::endl;
  x.print();
  std::cout << "Printing x through y:" << std::endl;
  y.print();

  return 0;
}
